#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1400five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 1400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five14004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five14004xi = {
                1: '-1002x510y832z',
                2: '-1014x374y889z',
                3: '-101x0y1396z',
                4: '-1022x896y331z',
                5: '-1035x461y821z',
                6: '-1040x324y878z',
                7: '-1064x271y867z',
                8: '-1065x409y810z',
                9: '-1071x843y318z',
                10: '-1086x216y856z',
                11: '-1093x355y798z',
                12: '-1104x160y845z',
                13: '-1116x788y304z',
                14: '-1118x299y787z',
                15: '-1119x103y834z',
                16: '-1140x242y775z',
                17: '-1158x183y763z',
                18: '-1158x730y290z',
                19: '-116x440y1323z',
                20: '-1174x123y752z',
                21: '-1186x62y740z',
                22: '-1195x0y728z',
                23: '-1197x669y277z',
                24: '-1212x48y881z',
                25: '-1233x607y263z',
                26: '-1265x543y249z',
                27: '-1294x477y235z',
                28: '-1320x409y222z',
                29: '-1341x340y208z',
                30: '-1359x269y194z',
                31: '-1374x198y180z',
                32: '-1384x126y166z',
                33: '-1390x54y152z',
                34: '-143x446y1319z',
                35: '-148x870y1086z',
                36: '-149x946y1020z',
                37: '-153x1291y518z',
                38: '-16x5y1399z',
                39: '-171x450y1314z',
                40: '-196x871y1077z',
                41: '-199x452y1309z',
                42: '-201x946y1011z',
                43: '-221x1286y505z',
                44: '-229x453y1304z',
                45: '-244x870y1068z',
                46: '-253x944y1001z',
                47: '-259x452y1299z',
                48: '-289x1278y492z',
                49: '-289x448y1294z',
                50: '-293x866y1059z',
                51: '-305x939y991z',
                52: '-30x8y1399z',
                53: '-320x443y1288z',
                54: '-342x860y1050z',
                55: '-351x436y1283z',
                56: '-357x1265y479z',
                57: '-357x931y981z',
                58: '-381x426y1277z',
                59: '-391x850y1040z',
                60: '-3x1y1399z',
                61: '-409x920y971z',
                62: '-412x415y1271z',
                63: '-424x1249y465z',
                64: '-42x413y1336z',
                65: '-440x838y1031z',
                66: '-443x401y1265z',
                67: '-44x9y1399z',
                68: '-461x906y961z',
                69: '-473x385y1259z',
                70: '-488x822y1021z',
                71: '-491x1230y452z',
                72: '-503x368y1253z',
                73: '-513x889y951z',
                74: '-532x348y1247z',
                75: '-536x804y1012z',
                76: '-557x1206y439z',
                77: '-560x325y1240z',
                78: '-564x869y941z',
                79: '-584x783y1002z',
                80: '-587x301y1234z',
                81: '-58x9y1398z',
                82: '-613x275y1227z',
                83: '-614x846y930z',
                84: '-621x1179y426z',
                85: '-630x759y992z',
                86: '-638x247y1220z',
                87: '-65x423y1332z',
                88: '-662x217y1213z',
                89: '-664x819y920z',
                90: '-676x732y982z',
                91: '-684x1149y412z',
                92: '-684x185y1206z',
                93: '-705x152y1199z',
                94: '-712x790y909z',
                95: '-720x703y972z',
                96: '-724x117y1192z',
                97: '-73x8y1398z',
                98: '-741x80y1185z',
                99: '-745x1115y399z',
                100: '-756x42y1177z',
                101: '-758x758y898z',
                102: '-763x670y962z',
                103: '-768x2y1169z',
                104: '-804x724y888z',
                105: '-805x1077y385z',
                106: '-805x635y952z',
                107: '-845x598y942z',
                108: '-847x686y877z',
                109: '-863x1037y372z',
                110: '-87x5y1397z',
                111: '-883x558y931z',
                112: '-889x646y866z',
                113: '-90x432y1328z',
                114: '-919x515y921z',
                115: '-919x993y358z',
                116: '-929x603y855z',
                117: '-953x470y910z',
                118: '-967x558y844z',
                119: '-972x946y345z ',
                120: '-984x424y900z',
                121: '-99x942y1030z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1400five4xi" usage = "target function for charge14004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire1400five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1400FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1400FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1400FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1400FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1400FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five14004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1400FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1400FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1400FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five14004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five14004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1400FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1400FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1400FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1400five4xi.py                             
# -------------------------------------------------------------------------------------------------                